function DesignerCB(action)
% DesignerCB Designer CallBacks
% Covering function colours:
%	green      ... recommended to specify and run
%	light blue ... just specified
%	blue       ... processed
%	red        ... not allowed to run
switch(action)
case('CreateFigure')     %PN: it is necessary to provide basic environment for all covering functions
%initialization
	red=[ 1 0 0 ];
	green=[ 0 1 0 ];
   set(findobj(gcf,'Style','togglebutton','String','Data handling'),'Value',0,'BackgroundColor',green)
   set(findobj(gcf,'Style','togglebutton','String','Control specification'),'BackgroundColor',red)
   set(findobj(gcf,'Style','togglebutton','String','Structure estimation'),'BackgroundColor',red)
   set(findobj(gcf,'Style','togglebutton','String','Parameter estimation'),'BackgroundColor',red)
   set(findobj(gcf,'Style','togglebutton','String','Prior knowledge'),'BackgroundColor',red)
   set(findobj(gcf,'Style','togglebutton','String','Parameter estimation'),'BackgroundColor',red)
   set(findobj(gcf,'Style','togglebutton','String','Forgetting estimation'),'BackgroundColor',red)
   set(findobj(gcf,'Style','togglebutton','String','Control verification'),'BackgroundColor',red)
case('CreateDataHandling')
   set(gcbo,'Value',0)
case('DataHandling')
   if revert_value
      %control of usage of suitable figures: already open or old
      figure_handle=findobj('Type','figure','Name','Data Specification')
	   if isempty(figure_handle)
		   open DataSpecOld.fig
	   else
   	   figure(figure_handle)
      end
   end   
case('CreatePriorKnowledge')
   set(gcbo,'Value',1)
case('PriorKnowledge')
   if revert_value
	   %control of usage of suitable figures: already open or old
   	figure_handle=findobj('Type','figure','Name','Prior Knowledge Specification')
	   if isempty(figure_handle)
   	   open PrKnSpecOld.fig
	   else
   	   figure(figure_handle)
      end
   end   
case('CreateStructureEstimation')
   set(gcbo,'Value',1)
case('StructureEstimation')
   if revert_value
	   %control of usage of suitable figures: already open or old
   	figure_handle=findobj('Type','figure','Name','Prior Model Structure Specification')
	   if isempty(figure_handle)
   	   open PrModStrSpecOld.fig
	   else
   	   figure(figure_handle)
      end
   end   
case('CreateForgettingEstimation')
   set(gcbo,'Value',1)
case('ForgettingEstimation')
   if revert_value
	   %control of usage of suitable figures: already open or old
   	figure_handle=findobj('Type','figure','Name','Forgetting Specification')
	   if isempty(figure_handle)
   	   FrgSpecOld
	   else
   	   figure(figure_handle)
      end
   end   
case('CreateParameterEstimation')
   set(gcbo,'Value',1)
case('ParameterEstimation')
   if revert_value
		PropagateChanges('Parameters')      
   end   
case('CreateControlDesign')
   set(gcbo,'Value',1)
case('ControlDesign')
   if revert_value
	   %control of usage of suitable figures: already open or old
   	figure_handle=findobj('Type','figure','Name','Control Design Specification')
	   if isempty(figure_handle)
   	   open ControlSpecOld.fig
	   else
   	   figure(figure_handle)
      end
   end   
case('CreateControlVerification')
   set(gcbo,'Value',1)
case('ControlVerification')
   if revert_value
	   %control of usage of suitable figures: already open or old
   	figure_handle=findobj('Type','figure','Name','Control Verification Specification')
	   if isempty(figure_handle)
   	   open VerificationSpecOld.fig
	   else
   	   figure(figure_handle)
      end
   end   
case('DataSimulation')
   open DataSpec.fig
case('SavedData')
   open DataSpec.fig
   DataSpecCB 'SavedData'
case('DataSpecOld')
   open DataSpecOld.fig
case('PrModStrSpecOld')
	open PrModStrSpecOld.fig
case('PrKnSpecOld')
	open PrKnSpecOld.fig
case('FrgSpecOld')
   open FrgSpecOld.fig
case('ControlSpecOld')
   open ControlSpecOld.fig
case('Structure')
   open PrModStrSpec.fig
case('OK')   
   data_figure_handle=findobj('Type','figure')
   close(data_figure_handle)  %all figures are found, but not DataSpec ???
   close
case('Next')
   if ~get(findobj(gcf,'String','Data handling'),'Value')
	   open DataSpecOld.fig
   end   
   if ~get(findobj(gcf,'String','Control specification'),'Value')
	   open ControlSpecOld.fig
   end 
   if ~get(findobj(gcf,'String','Structure estimation'),'Value')
		open PrModStrSpecOld.fig
   end   
   if ~get(findobj(gcf,'String','Prior knowledge'),'Value')
		open PrKnSpecOld.fig
   end   
   if ~get(findobj(gcf,'String','Parameter estimation'),'Value')
		PropagateChanges('Parameters')      
   end   
   if ~get(findobj(gcf,'String','Forgetting estimation'),'Value')
	   open FrgSpecOld.fig
   end   
   if ~get(findobj(gcf,'String','Control verification'),'Value')
  	   open VerificationSpecOld.fig
   end 
case('Cancel')
   clear
   close all
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function any_action=revert_value
%function revert_value reverts value of toglebutton, to be stable, not changable by clicking
% and checks whether this button is in state, when it can initiate any processing

red=[ 1 0 0 ];
if all(get(gcbo,'BackgroundColor')==red)
   any_action=0
else
   any_action=1
	if get(gcbo,'Value')      
   	set(gcbo,'Value',0)
	else
   	set(gcbo,'Value',1)
   end
end


