function NextToggleButtonCB(action)
%NextToggleButtonCB controls appearance of toggle buttons on the main figure. It sets corresponding button(s) to
% green, blue, ... . It is initiated by OK and Modify buttons of figure corresponding to action or by Next button 
% of the main figure.
main_figure=findobj('Type','figure','Tag','Designer')
blue=[ 0 0.501960784313725 1 ];							%everything connected with this step was processed
lightBlue=[ 0.501960784313725 1 1 ];					%everything connected with this step was inputed
red=[ 1 0 0 ];													%it is not allowed to process this step
green=[ 0 1 0 ];												%it is allowed to process this step
white=[ 1 1 1 ];												%it is a foreground color for blue background
darkGreen=[0 0.501960784313725 0.501960784313725];
black = [0 0 0];
switch(action)
case('DataHandling')   
   set(findobj(main_figure,'Style','togglebutton','String','Data handling'),'Value',1,'BackgroundColor',blue,'ForegroundColor',white)
   set(findobj(main_figure,'Style','togglebutton','String','Control specification'),'Value',0,'BackgroundColor',green,'ForegroundColor',black)
case('ControlSpecification')
   set(findobj(main_figure,'Style','togglebutton','String','Control specification'),'Value',1,'BackgroundColor',lightBlue)
   set(findobj(main_figure,'Style','togglebutton','String','Structure estimation'),'Value',0,'BackgroundColor',green,'ForegroundColor',black)
case('StructureSpecification')
   set(findobj(main_figure,'Style','togglebutton','String','Structure estimation'),'Value',1,'BackgroundColor',lightBlue)
   set(findobj(main_figure,'Style','togglebutton','String','Prior knowledge'),'Value',0,'BackgroundColor',green,'ForegroundColor',black)
   set(findobj(main_figure,'Style','togglebutton','String','Parameter estimation'),'BackgroundColor',darkGreen,'ForegroundColor',white)
case('StructureEstimation')
   set(findobj(main_figure,'Style','togglebutton','String','Structure estimation'),'BackgroundColor',blue,'ForegroundColor',white)
case('PriorKnowledgeSpecification')
   set(findobj(main_figure,'Style','togglebutton','String','Prior knowledge'),'Value',1,'BackgroundColor',lightBlue)
   set(findobj(main_figure,'Style','togglebutton','String','Parameter estimation'),'Value',0,'BackgroundColor',darkGreen,'ForegroundColor',white)
case('PriorKnowledge')
   set(findobj(main_figure,'Style','togglebutton','String','Prior knowledge'),'Value',1,'BackgroundColor',blue,'ForegroundColor',white)
case('ParameterEstimation')
   set(findobj(main_figure,'Style','togglebutton','String','Parameter estimation'),'Value',1,'BackgroundColor',blue,'ForegroundColor',white)
   set(findobj(main_figure,'Style','togglebutton','String','Forgetting estimation'),'Value',0,'BackgroundColor',green,'ForegroundColor',black)
case('ControlDesign')
   set(findobj(main_figure,'Style','togglebutton','String','Control specification'),'Value',1,'BackgroundColor',blue,'ForegroundColor',white)
   set(findobj(main_figure,'Style','togglebutton','String','Forgetting estimation'),'Value',0,'BackgroundColor',green,'ForegroundColor',black)
case('ForgettingEstimation')
   set(findobj(main_figure,'Style','togglebutton','String','Forgetting estimation'),'Value',1,'BackgroundColor',blue,'ForegroundColor',white)
   set(findobj(main_figure,'Style','togglebutton','String','Control verification'),'Value',0,'BackgroundColor',green,'ForegroundColor',black)
case('ControlVerification')
   set(findobj(main_figure,'Style','togglebutton','String','Control verification'),'Value',1,'BackgroundColor',blue,'ForegroundColor',white)
end
