%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function order=OrderDetermination
%Function OrderDetermination reads Model structure parameters and determines its order

str_figure=findobj('Type','figure','Name','Prior Model Structure Specification')
figure(str_figure)

MinInputDelay_object=findobj(str_figure,'Tag','MinInputDelay')
MinInputDelay=get(MinInputDelay_object,'String')   
MinInputDelay=str2num(MinInputDelay)       
if isempty(MinInputDelay)
   MinInputDelay=0
end
MaxInputDelay_object=findobj(str_figure,'Tag','MaxInputDelay')
MaxInputDelay=get(MaxInputDelay_object,'String')   
MaxInputDelay=str2num(MaxInputDelay)
if isempty(MaxInputDelay)
   MaxInputDelay=0
end
if MinInputDelay>MaxInputDelay
   warndlg('Min input delay should not be greater then max input delay.','Warning')
end
MinOutputDelay_object=findobj(str_figure,'Tag','MinOutputDelay')
MinOutputDelay=get(MinOutputDelay_object,'String')   
MinOutputDelay=str2num(MinOutputDelay)
if isempty(MinOutputDelay)
   MinOutputDelay=0
end
if MinOutputDelay<1
   warndlg('Min output delay should be at least 1.')   
end
MaxOutputDelay_object=findobj(str_figure,'Tag','MaxOutputDelay')
MaxOutputDelay=get(MaxOutputDelay_object,'String')   
MaxOutputDelay=str2num(MaxOutputDelay)
if isempty(MaxOutputDelay)
   MaxOutputDelay=0
end
if MinOutputDelay>MaxOutputDelay
   warndlg('Min output delay should not be greater then max output delay.','Warning')   
end
order=max(MaxInputDelay,MaxOutputDelay)