function PrKnSpecCB(action)
% PrKnSpecCB Prior Knowledge CallBack
global data des str frg pri Pri Model
tag=get(gcbo,'tag')  %get tag value of control identifying other controls (row)
switch(action)
   case('checkbox')
      %control visibility of texts for grouped items
      texts=[]
      texts=[texts; findobj(gcbf,'Style','text','String','Add')]
      texts=[texts; findobj(gcbf,'Style','text','String','List of lists')]      
      texts=[texts; findobj(gcbf,'Style','text','String','Del')]
      ch1=get(findobj(gcbf,'Style','checkbox','Tag','Gain'),'Value')
      ch2=get(findobj(gcbf,'Style','checkbox','Tag','Fr-char'),'Value')
      ch3=get(findobj(gcbf,'Style','checkbox','Tag','Cut-off'),'Value')
      ch4=get(findobj(gcbf,'Style','checkbox','Tag','Range'),'Value')
      ch5=get(findobj(gcbf,'Style','checkbox','Tag','Time'),'Value')      
      %it was tried to do it in this strange way - natural way was not operating
      ch=ch4 | ch5
      
      %making that when checkbox is on, corresponding control(s) are visible and v.v.
      if get(gcbo,'value') %set visibility according to value of checkbox
         visible='on'
         if ch
            set(texts,'Visible','on')
         end
      else
         visible='off'
         set(findobj(gcf,'tag',tag,'Style','popupmenu'),'String',[],'Value',0) %empty corresponding list
         if ~ch
            set(texts,'Visible','off')
         end
      end
      set(gcbo,'HandleVisibility','off')   %next find finds objects without checkbox
      object=findobj(gcf,'tag',tag)  %fing corresponding control(s) handle(s)
      set(gcbo,'HandleVisibility','on')    %back with handling visibility
      set(object,'Visible',visible)  %set its (their) visibility according previous results
      %change of visibility means initialization of corresponding controls
      set(findobj(gcf,'Tag',tag,'Style','radiobutton'),'Visible','off')
      set(findobj(gcf,'Tag',tag,'Style','popupmenu'),'Visible','off')
      set(findobj(gcf,'Tag',tag,'Style','edit'),'String','')
      
      ch_mm=ch1 | ch2 | ch3| ch4 | ch5
      if ch_mm
         set(findobj(gcbf,'Tag','MinMax','Style','text'),'Visible','on')
      else
         set(findobj(gcbf,'Tag','MinMax','Style','text'),'Visible','off')
      end

      if strcmp(tag,'Steady')
         steady_object=findobj(gcbf,'Style','checkbox','Tag','Steady')
         if get(steady_object,'Value')
            [file_name,file_path]=uigetfile('*.mat','Select file to open for steady state signals')
            if (file_name==0)
               set(object,'Visible','off')  
               set(steady_object,'Visible','on','Value',0)  
               return
            end         
            [token,ext]=strtok(file_name,'.')   %tokens are separated by period
            ext=strrep(ext,'.','')              %erase point
            switch (ext)
               case ('mat')
                  load([file_path,file_name])
                  if isempty(steady_basic_matrix)
                     warndlg(['Selected file does not contain proper matrix. (Its name must be ''steady_basic_matrix''.)'])
                     return
                  end
            end %switch
            set(steady_object,'UserData',steady_basic_matrix)
            steady_display
         end
      end
      ModifyNextCB('ButtonDown')
   case('edit')
      %any "change" of edit field may activate Add radiobutton
      string=get(gcbo,'String')
      if isempty(string)
         set(findobj(gcf,'Tag',tag,'Style','radiobutton','String','Add'),'Visible','off')
      else
         set(findobj(gcf,'Tag',tag,'Style','radiobutton','String','Add'),'Visible','on','Value',0)
      end   
      ModifyNextCB('ButtonDown')
   case('add')
      edit_object_min=findobj(gcf,'tag',tag,'Style','edit','UserData','Min')
      edit_min=get(edit_object_min,'String')
      if isempty(edit_min)
         warndlg(['When you selected to add ' tag ' type of prior knowledge, you must have prepared it. You should specify minimum value.'])
         set(findobj(gcbf,'Tag',tag,'Style','radiobutton','String','Add'),'Visible','off')
         return
      end
      edit_object_max=findobj(gcf,'tag',tag,'Style','edit','UserData','Max')  
      edit_max=get(edit_object_max,'String')
      if isempty(edit_max)
         warndlg(['When you selected to add ' tag ' type of prior knowledge, you must have prepared it. You should specify maximum value.'])
         set(findobj(gcbf,'Tag',tag,'Style','radiobutton','String','Add'),'Visible','off')
         return
      end
      edit_string=[num2str(edit_min),',',num2str(edit_max)]
      
      %fing corresponding popupmenu handle(s)
      popupmenu_object=findobj(gcf,'tag',tag,'Style','popupmenu')  
      visible=get(popupmenu_object,'Visible')
      s1=size(visible)
      if s1==[1 3]   %'off' ie. "empty" popupmenu
         set(popupmenu_object,'Visible','on')
         set(findobj(gcf,'Tag',tag,'Style','radiobutton','String','Del'),'Visible','on')
         string=edit_string
         set(popupmenu_object,'String',string)      
         set(popupmenu_object,'Value',1)      
      else                        %"non-empty" popupmenu
         string=get(popupmenu_object,'String')
         s1=size(edit_string)     %partial strings have to have the same length
         s2=size(string)
         d=s1(2)-s2(2)
         if d>0
            string=[string,repmat(' ',s2(1),d)]
         else
            edit_string=[edit_string,repmat(' ',s1(1),-d)]
         end   
         string=[string;edit_string]%composition of new string
         set(popupmenu_object,'String',string)      
         set(popupmenu_object,'Value',get(popupmenu_object,'Value')+1)      
      end
      set(edit_object_min,'String','')
      set(edit_object_max,'String','')
      set(gcbo,'Value',0,'Visible','off')
      ModifyNextCB('ButtonDown')
   case('del')
      %delete just selected element from popupmenu
      object=findobj(gcf,'tag',tag,'Style','popupmenu')  
      %fing corresponding popupmenu handle
      index=get(object,'Value')       %get index of element
      if index==0 return 
      end
      string=get(object,'String')     %get all menu elements
      s1=size(string)                 %get size of menu
      %assuring_figure
      %(['You really intend to delete item ''',string(index,:),'''?'])
      %userData_size=size(get(gcf,'UserData'))
      %if userData_size(2)~=2             %'OK' 
      %   get(gcf,'UserData')
      %   return 
      %end                             %check if it is serious
      string=[string(1:index-1,:);string(index+1:s1(1),:)]  %new menu
      if isempty(string)
         set(object,'Visible','off')  %"empty" popupmenu is invisible
         set(gcbo,'Visible','off','Value',0)  %and corresponding Del radiobutton too
      else
         set(object,'Value',s1(1)-1)      
         set(object,'String',string)  %set new menu
         set(gcbo,'Value',0)          %reset radiobox
      end
      ModifyNextCB('ButtonDown')
   case('OK')
      KnowledgePreparation
      close(gcbf)
      return
   case('Modify')
      KnowledgePreparation
      ModifyNextCB(action)
   case('Cancel')
      close(gcbf)
      return
   case('CreateSteady')      
      steady_display
   case('CreateOK')
      TestApplicability(gcbo,'Knowledge')
   case('CreateModify')
      TestApplicability(gcbo,'Knowledge')
   case('Next')
      ModifyNextCB(action)
   case('CreateNext')
      TestApplicability(gcbo,'Knowledge')
      set(gcbo,'Visible','off')

   end
   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
function KnowledgePreparation
%Function KnowledgePreparation reads final Knowledge parameters and prepares encoded prior knowledge
%prior knowledge is not processed until Model structure is determined
global des pri pre
%pri=[];str=[];frg=[];Model=[];   %all is dependent on prior knowledge and must be changed
if isempty(des)
   warndlg('Signal description is not specified. This window shall be closed. Specify Data (in Designer main menu) and then you can return.','Warning')
   close(gcbf)
   return
end

%feeds knowledge items into prior knowledge structure
%feeds knowledge single items
cell_index=1                    %initial cell index
cell_index=feed_prior('Gain','g',cell_index)
cell_index=feed_prior('Cut-off','c',cell_index)
cell_index=feed_prior('Fr-char','a',cell_index)

%feeds knowledge group items
cell_index=feed_prior_group('Range','r',cell_index)
cell_index=feed_prior_group('Time','t',cell_index)
cell_index=feed_prior_steady('Steady','m',cell_index)
if cell_index==1
   pri=[]
end

drawnow
PropagateChanges('Knowledge')
      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function di=disassembly(string)
%string separated by commas disassembly
string_to_dis=string
while ~isempty(string)
   di=[]  
   [token,string]=strtok(string,',')   %tokens are separated by columns
   di=[di,token]
end
return

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function cell_index_new=feed_prior(tag,ti,cell_index)
%function feed_prior feeds knowledge items into prior knowledge structure

global pri
%there can be only two values for knowledge items
if get(findobj(gcbf,'Style','checkbox','Tag',tag),'Value')
   di_min=get(findobj(gcbf,'Style','edit','Tag',tag,'UserData','Min'),'String')
   if isempty(di_min)           %MATLAB is falling when empty [] is set into cell4 
      warndlg(['When you selected to specify ' tag ' type of prior knowledge, you must do it. You should specify minimum value.'])
      return
   end
   di_min=str2num(di_min)
   
   di_max=get(findobj(gcbf,'Style','edit','Tag',tag,'UserData','Max'),'String')
   if isempty(di_max)           %MATLAB is falling when empty [] is set into cell4 
      warndlg(['When you selected to specify ' tag ' type of prior knowledge, you must do it. You should specify maximum value.'])
      return
   end
   di_max=str2num(di_max)
   matrix=[di_min di_max]
   if strcmp(tag,'Fr-char')
      di_Freq=get(findobj(gcbf,'Style','edit','Tag',tag,'UserData','Freq'),'String')
      if isempty(di_Freq)           %MATLAB is falling when empty [] is set into cell4 
         warndlg(['When you selected to specify ' tag ' type of prior knowledge, you must do it. You should specify frequency value.'])
         return
      end
      di_Freq=str2num(di_Freq)
      di_Phase=get(findobj(gcbf,'Style','edit','Tag',tag,'UserData','Phase'),'String')
      if isempty(di_Phase)           %MATLAB is falling when empty [] is set into cell4 
         warndlg(['When you selected to specify ' tag ' type of prior knowledge, you must do it. You should specify phase value.'])
         return
      end
      di_Phase=str2num(di_Phase)
      matrix=[matrix di_Freq di_Phase]
   end
   
   if cell_index==1
      pri=cellvect(ti,matrix)
   else
      pri=setcell(pri,cell_index,ti)
      pri=setcell(pri,cell_index+1,matrix)
   end   
   cell_index_new=cell_index+2
else
   cell_index_new=cell_index
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function cell_index_new=feed_prior_group(tag,ti,cell_index)
%function feed_prior_group feeds knowledge group items into prior knowledge structure

global pri
%there can be only two values for knowledge items
if get(findobj(gcbf,'Style','checkbox','Tag',tag),'Value')
   kn_matrix=get(findobj(gcbf,'Style','popupmenu','Visible','on','Tag',tag),'String')
   if isempty(kn_matrix)           %MATLAB is falling when empty [] is set into cell4 
      warndlg(['When you selected to specify ' tag ' type of prior knowledge, you must do it. You should specify values.'])
      return
   end
   s2=size(kn_matrix)
   for i2=1:s2(1)               %prepare di for each knowledge item
      kn_element=str2num(kn_matrix(i2,:))
      di=disassembly(kn_element)
      if ~isempty(di)           %MATLAB is falling when empty [] is set into cell4 
         if cell_index==1
            pri=cellvect(ti,di)
         else            
            pri=setcell(pri,cell_index,ti)      
            pri=setcell(pri,cell_index+1,di)
         end         
         cell_index_new=cell_index+2
      end
   end   
else
   cell_index_new=cell_index
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function cell_index_new=feed_prior_steady(tag,ti,cell_index)
%function feed_prior_steady feeds knowledge about steady state signals into prior knowledge structure

global des pri
if get(findobj(gcbf,'Style','checkbox','Tag','Steady'),'Value')
   i_precision=get(findobj(gcbf,'Style','edit','Tag','Steady','UserData','input'),'String')
   if isempty(i_precision)
      i_precision=0
   else
      i_precision=str2num(i_precision)
   end   
   o_precision=get(findobj(gcbf,'Style','edit','Tag','Steady','UserData','output'),'String')
   if isempty(o_precision)
      o_precision=0
   else
      o_precision=str2num(o_precision)
   end 
   
   matrix=get(findobj(gcbf,'Style','checkbox','Tag','Steady'),'UserData')
   matrix_size=size(matrix)
   matrix_of_ones=ones(matrix_size(1))         %with the same # of rows
   precision(findstr(des,'i'))=i_precision
   precision(findstr(des,'o'))=o_precision
   steady_matrix=[matrix.*(matrix_of_ones*(1-precision)), matrix.*(matrix_of_ones*(1+precision))]'
   if cell_index==1
      pri=cellvect(ti,steady_matrix)
   else
      pri=setcell(pri,cell_index,ti)
      pri=setcell(pri,cell_index+1,steady_matrix)
   end   
   cell_index_new=cell_index+2
else
   cell_index_new=cell_index
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function steady_display
%function steady_display displays steady_basic_matrix
global des

steady_object=findobj(gcbf,'Style','checkbox','Tag','Steady')
if get(steady_object,'Value')&...
      ~isempty(get(steady_object,'UserData'))
   steady_basic_matrix=get(steady_object,'UserData')
   input=findstr(des,'i')
   output=findstr(des,'o')
   steady_cell={}
   steady_cell{input}=['steady state input  : ',num2str(steady_basic_matrix(input))]
   steady_cell{output}=['steady state output: ',num2str(steady_basic_matrix(output))]
   msgbox(steady_cell)
end