%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function PrepareTable(tag_extension,slider_cb,struct)
%Function PrepareTable prepares table fot Model structure processing
%parameters:
%   tag_extension ... extension of tag of slider to recognize prepared table
%   slider_cb     ... 1 (CallBack) resp 0, ie. where from function is called

str_figure=findobj('Type','figure','Name','Prior Model Structure Specification')
figure(str_figure)

texts=findobj(str_figure,'Tag','First_texts_N')
text=texts(2)         %it is necessary to take text from table
text_position=get(text,'Position')
left_margin=text_position(1)
text_width=text_position(3)
figure_width=get(str_figure,'Position')
figure_width=figure_width(3)
objects(1)=findobj(str_figure,'Tag','Output_0_N')
position=get(objects(1),'Position')
shift=position(3)          %get horizontal shift between columns
max_no_of_visible=floor((figure_width-2*left_margin-text_width)/shift)
slider=findobj(str_figure,'Style','slider','Tag',['Slider' tag_extension])
if tag_extension=='_N'
   order=OrderDetermination
end
if tag_extension=='_E'
   if isempty(struct)
      order=0
   else      
      order=max(struct(2,:))        %derive max order as max delay in second row of struct
   end   
end
if max_no_of_visible<order+1 %space is not enough   
   if slider_cb==0   %not called from CallBack - it is slider initiation
      set(slider,'Value',0)
      set(slider,'Min',0)
      set(slider,'Max',order+1-max_no_of_visible)
      set(slider,'Visible','on')
      ProduceTable(order,0,max_no_of_visible-1,tag_extension,slider_cb,str_figure)
   else
      slider_value=floor(get(slider,'Value'))
      ProduceTable(order,slider_value,slider_value-1+max_no_of_visible,tag_extension,slider_cb,str_figure)
   end
else
   set(slider,'Visible','off')
   ProduceTable(order,0,order,tag_extension,slider_cb,str_figure)
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ProduceTable(order,min,max,tag_extension,slider_cb,str_figure)
%Function ProduceTable produces table for presenting the (part) of structure

objects(2)=findobj(str_figure,'Tag',['Delay_0' tag_extension])
objects(1)=findobj(str_figure,'Tag',['Output_0' tag_extension])
objects(3)=findobj(str_figure,'Tag',['Input_0' tag_extension])

if slider_cb==0
   DeleteOldFields(tag_extension)
   texts=findobj(str_figure,'Tag',['First_texts' tag_extension])
   set(texts,'Visible','on')     %turn first text to be visible

   %copy all necessary table fields
   set(objects(1),'value',0)     %for copying nulified fields
   set(objects(3),'value',0)     %for copying nulified fields
   set(objects,'Visible','off')  %for copying turn first column not to be visible
   for i1=1:order                %make column for each delay
      if i1~=0
         copied_objects=copyobj(objects,str_figure)   % copy fields of the first column
         set(copied_objects(2),'String',i1)
         %set tags to recognize table fields
         set(copied_objects(1),'Tag',['Output_' num2str(i1) tag_extension])   
         set(copied_objects(3),'Tag',['Input_' num2str(i1) tag_extension])    
         set(copied_objects(2),'Tag',['Text_next' num2str(i1) tag_extension])             
      end
   end
else
   for i1=1:order                %make all invisible
      copied_objects(1)=findobj(str_figure,'Tag',['Output_' num2str(i1) tag_extension])   
      copied_objects(3)=findobj(str_figure,'Tag',['Input_' num2str(i1) tag_extension])    
      copied_objects(2)=findobj(str_figure,'Tag',['Text_next' num2str(i1) tag_extension])
      set(copied_objects,'Visible','off')
   end      
end

%position visible table fields
position=get(objects(2),'Position')
initial_position=position(1)
shift=position(3)                %get horizontal shift between columns
for i1=min:max                   %manage visible column for each delay
   if i1~=0
      copied_objects(1)=findobj(str_figure,'Tag',['Output_' num2str(i1) tag_extension])   
      copied_objects(3)=findobj(str_figure,'Tag',['Input_' num2str(i1) tag_extension])    
      copied_objects(2)=findobj(str_figure,'Tag',['Text_next' num2str(i1) tag_extension])

      for j1=1:3                                       %for each field in column
         position=get(copied_objects(j1),'Position')   %get position of first of copied fields
         position(1)=initial_position+(i1-min)*shift   %prepare shift
         set(copied_objects(j1),'Position',position)   %and shift it 
         set(copied_objects(j1),'Visible','on')        %and make visible
      end
   end
end
if min==0
   set(objects,'Visible','on')                         %turn first column to be visible
end
set(objects(1),'Visible','off')                        %turn output field of first column to be invisible

