function TestApplicability(gcbo_handle,type)
%function TestApplicability tests whether corresponding button is applicable (should be 
%     visible)
%     it is called from corresponding button cases from particular step figures
global input output data des str Pri frg
%in following tests, data prerequisits for all types of processing (steps) are examined
%    processing types are tested with strcmp functions
%    prerequisites are tested with isempty functions
text=[]
if isempty(input)
   text=[text, ' input channel,']
end
if isempty(output)
   text=[text, ' output channel,']
end
if isempty(data)
   text=[text, ' controlled system data,']
end
if isempty(des)
   text=[text, ' channel description,']
end
if strcmp(type,'Forgetting')%|strcmp(type,'Design')
   if isempty(str)
      text=[text, ' model structure,']
   end
end
%if strcmp(type,'Design')
   %if isempty(frg)
      %text=[text, ' forgetting,']
   %end
%end

if isempty(text)                                  %no warning
   set(gcbo_handle,'Visible','on')
else
   if strcmp(get(gcbo_handle,'String'),'OK')      %we need only one warning
      switch(type)
         case('Structure')
            first_part=['Prior model structure can be specified',...
               ' but model structure cannot be estimated']
            text=[first_part,' as information about',text,' is not yet created.']
         case('Knowledge')
            first_part=['Prior knowledge can be specified',...
               ' but cannot be processeded']
            text=[first_part,' as information about',text,' is not yet created.']
         case('Forgetting')
            first_part=['Forgetting can be specified',...
               ' but cannot be estimated']
            text=[first_part,' as information about',text,' is not yet created.']
         %case('Design')
            %first_part=['Controller design can be specified',...
               %' but cannot be processeded']
            %text=[first_part,' as information about',text,' is not yet created.']
      end         
      warndlg(text,'Required data not available')
   end
   set(gcbo_handle,'Visible','off')
end
