function VerificationSpecCB(action)
% Verification Specification CallBack
switch(action)
	case('System number')
         ModifyNextCB('ButtonDown')
   case('OK')
      VerificationPreparation
      NextToggleButtonCB('ControlVerification')
      close(gcbf)      
   case('Modify')
      VerificationPreparation
      ModifyNextCB(action)
      NextToggleButtonCB('ControlVerification')
   case('Cancel')
      close(gcbf) 
   case('CreateOK')
      TestApplicability(gcbo,'Verification')
   case('CreateModify')
      TestApplicability(gcbo,'Verification')      
   case('Next')
      ModifyNextCB(action)
   case('CreateNext')
      TestApplicability(gcbo,'Verification')
      set(gcbo,'Visible','off')
   end
   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
function VerificationPreparation
%Function VerificationPreparation reads Verification parameters and processes them
global des str ref systemNo
if isempty(des)
   warndlg('Chanels were not specified. You should specify it e.g. with Data command. Then you can return to this window.','Warning')
   return
end
if isempty(str)
   warndlg('Model Structure was not specified. You should specify it e.g. with Structure command. For the current design, no prior model structure is used.','Warning')
   return
end

if isempty(ref)
   warndlg('Reference values were not specified. You should specify it e.g. with Parameters command. ','Warning')
   return
end

systemNo=get(findobj(gcbf,'Style','edit','Tag','System number'),'String')
if isempty(systemNo) 
  	systemNo=10
else      
  	systemNo=str2num(systemNo)      
end;

drawnow
PropagateChanges('Verification')